package ch.usi.inf.sp.cfg.builder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MultiMap<K, V> {
    private final Map<K, List<V>> innerMap = new HashMap<>();

    public void put(K key, V value) {
        innerMap.computeIfAbsent(key, (k) -> new ArrayList<>());
        innerMap.get(key).add(value);
    }

    public List<V> getAll(K key) {
        return new ArrayList<>(innerMap.getOrDefault(key, List.of()));
    }

    public boolean containsKey(K key) {
        return innerMap.containsKey(key);
    }
}
