package ch.usi.inf.sp.dom;

import ch.usi.inf.sp.cfg.BasicBlock;
import ch.usi.inf.sp.graph.Node;


public class DominatorTreeNode extends Node<DominanceEdge> {

    private final BasicBlock block;


    public DominatorTreeNode(final BasicBlock block) {
        this.block = block;
    }

    public BasicBlock getBlock() {
        return block;
    }

    @Override
    public boolean equals(Object other) {
        return other instanceof DominatorTreeNode && block==((DominatorTreeNode)other).block;
    }

    @Override
    public String toString() {
        return "\"D("+block.getId()+")\"";
    }

}
