package ch.usi.inf.sp.graph;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


public class Node<E extends Edge> {

    private final ArrayList<E> inEdges;
    private final ArrayList<E> outEdges;

    public Node() {
        inEdges = new ArrayList<E>();
        outEdges = new ArrayList<E>();
    }

    public void addInEdge(E edge) {
        inEdges.add(edge);
    }

    public void addOutEdge(E edge) {
        outEdges.add(edge);
    }

    public List<E> getInEdges() {
        return Collections.unmodifiableList(inEdges);
    }

    public List<E> getOutEdges() {
        return Collections.unmodifiableList(outEdges);
    }

    public String toString() {
        return '"'+super.toString()+'"';
    }

}
