package ch.usi.inf.sp.graph;

import ch.usi.inf.sp.graph.Edge;
import ch.usi.inf.sp.graph.Node;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class NodeTest {

    @Test
    void newNode() {
        Node n = new Node();
        assertEquals(0, n.getInEdges().size());
        assertEquals(0, n.getOutEdges().size());
    }

    @Test
    void toStringTest() {
        Node n = new Node();
        assertEquals('"'+n.getClass().getName()+"@"+Integer.toHexString(n.hashCode())+'"', n.toString());
    }

    @Test
    void addInEdge() {
        Node n = new Node();
        Edge e = new Edge();
        n.addInEdge(e);
        assertEquals(1, n.getInEdges().size());
        assertSame(e, n.getInEdges().get(0));
    }

    @Test
    void addOutEdge() {
        Node n = new Node();
        Edge e = new Edge();
        n.addOutEdge(e);
        assertEquals(1, n.getOutEdges().size());
        assertSame(e, n.getOutEdges().get(0));
    }

}